﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Drawing;

namespace StackOverflowFlair.Extensions
{
    public static class GraphicsExtensions
    {
        public static SizeF MeasureDisplayString(this Graphics graphics, string text, Font font)
        {
            if (text == null)
            {
                text = "";
            }

            System.Drawing.StringFormat format = new System.Drawing.StringFormat();
            System.Drawing.RectangleF rect = new System.Drawing.RectangleF(0, 0, 1000, 1000);
            System.Drawing.CharacterRange[] ranges = { new System.Drawing.CharacterRange(0, text.Length) };
            System.Drawing.Region[] regions = new System.Drawing.Region[1];

            format.SetMeasurableCharacterRanges(ranges);

            regions = graphics.MeasureCharacterRanges(text, font, rect, format);
            if (regions.Length > 0)
            {
                rect = regions[0].GetBounds(graphics);

                return new SizeF(rect.Right - 1, rect.Bottom - 3);
            }
            else
            {
                return new SizeF(0.0f, 0.0f);
            }
        }
    }
}
